hdu 4738 Caocao's Bridges -有重边的无向图找桥

Caocao's Bridges

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5576    Accepted Submission(s): 1751


Problem Description
Caocao was defeated by Zhuge Liang and Zhou Yu in the battle of Chibi. But he wouldn't give up. Caocao's army still was not good at water battles, so he came up with another idea. He built many islands in the Changjiang river, and based on those islands, Caocao's army could easily attack Zhou Yu's troop. Caocao also built bridges connecting islands. If all islands were connected by bridges, Caocao's army could be deployed very conveniently among those islands. Zhou Yu couldn't stand with that, so he wanted to destroy some Caocao's bridges so one or more islands would be seperated from other islands. But Zhou Yu had only one bomb which was left by Zhuge Liang, so he could only destroy one bridge. Zhou Yu must send someone carrying the bomb to destroy the bridge. There might be guards on bridges. The soldier number of the bombing team couldn't be less than the guard number of a bridge, or the mission would fail. Please figure out as least how many soldiers Zhou Yu have to sent to complete the island seperating mission.
 

Input
There are no more than 12 test cases.

In each test case:

The first line contains two integers, N and M, meaning that there are N islands and M bridges. All the islands are numbered from 1 to N. ( 2 <= N <= 1000, 0 < M <= N 2 )

Next M lines describes M bridges. Each line contains three integers U,V and W, meaning that there is a bridge connecting island U and island V, and there are W guards on that bridge. ( U ≠ V and 0 <= W <= 10,000 )

The input ends with N = 0 and M = 0.
 

Output
For each test case, print the minimum soldier number Zhou Yu had to send to complete the mission. If Zhou Yu couldn't succeed any way, print -1 instead.
 

Sample Input
  
  
3 3 1 2 7 2 3 4 3 1 4 3 2 1 2 7 2 3 4 0 0
 

Sample Output
  
  
-1 4


/**
无向图,有重边的情况找最小的桥
题解:要消除反向边对其的影响,但是不能消除重边对其的影响,
因为存图时是按照正向边反向边存的,所以第一次遇到v==fa的一定是因为反向边而存下来的
*/
#include<iostream>
#include<cstdio>
#include<vector>
#include<sstream>
#include<cstring>
#include<algorithm>
#define mem(a,x) memset(a,x,sizeof(a))
#define INF 0x3f3f3f3f
using namespace std;
const int N = 1010;
struct node{
    int v,w,id;
    node(int v = 0,int w = 0,int id = 0):v(v),w(w),id(id){};
};
vector<node>G[N];
int pre[N];
int low[N];
int dfsLock;int ans ;int n,m;
void init(){
    mem(pre,0); mem(low,0);
    for(int i=0;i<=n;i++) G[i].clear();
    dfsLock = 0;ans = INF;
}
int dfs(int u,int fa){
    low[u] = pre[u] = ++dfsLock;
    int k = 1;
    for(int i=0;i<G[u].size();i++){
        int v = G[u][i].v;

        if(v == fa && k) {///没有重边则不需要这句话
            k = 0;continue;
        }

        if(!pre[v]){
            dfs(v,u);
            low[u] = min(low[u],low[v]);///用后代的low更新当前的
            if(low[v] > pre[u])
                ans = min(ans,G[u][i].w);
        }
        else
            low[u] = min(low[u],pre[v]);///利用后代v的反向边更新low
    }
}
int main(){
    int t;
    while(scanf("%d%d",&n,&m)!=EOF&& (n || m)){
        int a,b,c;
        init();
        for(int i=1;i<=m;i++){
            scanf("%d%d%d",&a,&b,&c);
            G[a].push_back(node(b,c,i));
            G[b].push_back(node(a,c,i));
        }
        int cnt = 0;
        for(int i=1;i<=n;i++){
            if(!pre[i]){
                cnt++;///连通图的个数
                dfs(i,-1);///根没有父亲,传-1
            }
        }
        if(cnt > 1) ///多于一个联通分量 不用派人
            ans = 0;
        else if(ans == INF)
            ans = -1;
        else if(ans == 0) ///没有人看守,也需要派一个人去炸桥
            ans = 1;
        printf("%d\n",ans);
    }
    return 0;
}

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值